#<profile4xi profile = "20" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "poolproxy4xi.py">
#<abstract4xi abstract = "provides type PoolProxy4Xi"/>
#<refer4xi reference = "managers.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'PoolProxy4Xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import weakref
    import array
    import queue
    from traceback import format_exc
    import copyreg         
except:
    pass
try:                 # rare ones
    pass          
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import PoolProxy
except:
    print("poolproxy4xi.py *** failed in from multiprocessing.managers import PoolProxy ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from baseproxy4xi import BaseProxy4Xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "MakeProxyType4Xi" usage = "
# embedded inside this module so that forkingpickler4xi detects this to be the module 
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def MakeProxyType4Xi(name, exposed, cache={}):
    '''
    MakeProxyType4Xi function: returns an proxy type whose methods are given by `exposed`;
    
    '''
    class2print = "MakeProxyType4Xi"
    method2print = "MakeProxyType4Xi"

    message2print = "{started" + "; MakeProxyType4Xi-started: " + str(MakeProxyType4Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{passed" + "; name-passed-to-MakeProxyType4Xi: " + str(name) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    message2print = "{passed" + "; exposed-passed-to-MakeProxyType4Xi: " + str(exposed) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    message2print = "{passed" + "; cache-passed-to-MakeProxyType4Xi: " + str(cache) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                      
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        

    exposed2xi = tuple(exposed)
   
    message2print = "{set" + "; exposed2xi-set-by-MakeProxyType4Xi to: " + str(exposed2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
            
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
        
    try:
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
           
        message2print = "{passing" + "; name-passing-to-cache-by-MakeProxyType4Xi: " + str(name) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        message2print = "{passing" + "; exposed2xi-passing-to-cache-by-MakeProxyType4Xi: " + str(exposed2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
           
        message2print = "{returning" + "; cache-by-MakeProxyType4Xi: " + str(cache[(name, exposed2xi)]) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        
                
        return cache[(name, exposed2xi)]
    except KeyError:
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
           
        message2print = "{hit" + "; KeyError-hit-by-MakeProxyType4Xi: " + " *** " + str(name)  + str(exposed2xi) + " *** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                  
        pass

    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        

    dic2xi = {}
 
        
    for meth2xi in exposed2xi:
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
           
        message2print = "{passing" + "; meth2xi-passing-to-exec-by-MakeProxyType4Xi: " + str(meth2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        message2print = "{passing" + "; dic2xi-passing-to-exec-by-MakeProxyType4Xi: " + str(dic2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
            
        exec('''def %s(self, *args, **kwds):
        return self._callmethod(%r, args, kwds)''' % (meth2xi, meth2xi), dic2xi)

    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    message2print = "{passing" + "; name-passing-to-type-by-MakeProxyType4Xi: " + str(name) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
    message2print = "{passing" + "; BaseProxy4Xi-passing-to-type-by-MakeProxyType4Xi: " + str(BaseProxy4Xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    
    message2print = "{passing" + "; dic2xi-passing-to-type-by-MakeProxyType4Xi: " + str(dic2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
     
            
    proxytype2xi = type(name, (BaseProxy4Xi,), dic2xi)
  
    
    
    proxytype2xi._exposed_ = exposed2xi

    message2print = "{set" + "; proxytype2xi-exposed-set-by-MakeProxyType4Xi to: " + str(proxytype2xi._exposed_)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
          
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    message2print = "{passing" + "; name-passing-to-cache-by-MakeProxyType4Xi: " + str(name) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    
    message2print = "{passing" + "; exposed2xi-passing-to-cache-by-MakeProxyType4Xi: " + str(exposed2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)           
                
    cache[(name, exposed2xi)] = proxytype2xi
    
    message2print = "{set" + "; cache-set-by-MakeProxyType4Xi to: " + str(cache[(name, exposed2xi)])  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
             
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        

    return proxytype2xi
#</function4xi>
 


# -------------------------------------------------------------------------------------------------
# Types                              
# -------------------------------------------------------------------------------------------------
#
#<type4xi type = "
PoolProxy4Xi = MakeProxyType4Xi('PoolProxy4Xi', (
    'apply', 'apply_async', 'close', 'imap', 'imap_unordered', 'join',
    'map', 'map_async', 'terminate',
    'sense', 'reason', 'ace'
    ))

    

# -------------------------------------------------------------------------------------------------
# _method_to_typeid_                             
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/> 
# -------------------------------------------------------------------------------------------------
#
PoolProxy4Xi._method_to_typeid_ = {    # each key in this dictionary, such as 'apply_async', is Pool4Xi method    
    'apply_async': 'AsyncResult',      
    'map_async': 'AsyncResult',        
    'imap': 'Iterator',                
    'imap_unordered': 'Iterator'}      
#"

#usage = "
#   managers.py
#       SyncManager.register('Pool', Pool, PoolProxy)
#   syncmanager4xi.py:
#       SyncManager4Xi.register('Pool4Xi', Pool4Xi, PoolProxy4Xi)
#"
#>

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of poolproxy4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
